package com.diagbot.facade;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.BillDTO;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.BillProcess;
import com.diagbot.vo.BillNeoVO;
import com.diagbot.vo.IndicationPushVO;
import com.diagbot.vo.PushVO;
import com.diagbot.vo.StandConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description: 推送facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class PushFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    BillProcess billProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 开单合理性业务
     * @param
     * @return
     */
    public BillDTO billFac(IndicationPushVO indicationPushVO) {
        // 模型处理数据 TODO
        WordCrfDTO wordCrfDTO = commonFacade.crf_process(indicationPushVO);
        StandConvert standConvert = commonFacade.dataTypeGet(wordCrfDTO);

        // 标准词转换 TODO
        Map<String, Map<String, String>> typeStand = neoFacade.standConvert(standConvert);
        wordCrfDTO = commonFacade.dataTypeSet(wordCrfDTO, typeStand);

        // 图谱接口调用
        BillNeoVO billNeoVO = fillBillNeo(indicationPushVO);

        List<BillNeoDTO> billNeoDTOs = neoFacade.getBillNeo(billNeoVO);

        // 规则开发 TODO
        neoFacade.getDrugCache();

        // TODO
        return null;
    }

    /**
     * 推送业务
     * @param
     * @return
     */
    public BillDTO pushFac(PushVO pushVo) {
        // 模型处理数据 TODO
        WordCrfDTO wordCrfDTO = commonFacade.crf_process(pushVo);
        StandConvert standConvert = commonFacade.dataTypeGet(wordCrfDTO);

        // 标准词转换 TODO
        Map<String, Map<String, String>> typeStand = neoFacade.standConvert(standConvert);
        wordCrfDTO = commonFacade.dataTypeSet(wordCrfDTO, typeStand);

        // TODO
        return null;
    }


    public BillNeoVO fillBillNeo(IndicationPushVO indicationPushVO) {
        BillNeoVO billNeoVO = new BillNeoVO();

        List<Item> items = indicationPushVO.getDrug();
        for (Item item : items) {
            billNeoVO.getDrugList().add(item.getName());
        }

        return billNeoVO;
    }
}
